Index: LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmdiso/phys_output_mod.F90	(revision 4046)
@@ -35,6 +35,7 @@
     USE iophy 
     USE dimphy
-    USE infotrac_phy, ONLY: nqtot, nqo, niadv, tname, ttext, type_trac, &
+    USE infotrac_phy, ONLY: nqtot, nqo, niadv, tracers, type_trac, &
         nqtottr,itr_indice ! C Risi
+    USE strings_mod,  ONLY: maxlen
     USE ioipsl
     USE phys_cal_mod, only : hour, calend
@@ -124,8 +125,10 @@
 
 #ifdef ISO
-      INTEGER  :: ixt,iiso,izone
-      CHARACTER*50 :: striso_sortie
-      integer :: lnblnk
-#endif
+    INTEGER  :: ixt,iiso,izone
+    CHARACTER(LEN=50) :: outiso
+    CHARACTER(LEN=20) :: unit
+#endif
+    CHARACTER(LEN=maxlen) :: tnam, lnam, dn
+    INTEGER :: flag(nfiles)
 
 !!!!!!!!!! stockage dans une region limitee pour chaque fichier !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -534,92 +537,47 @@
         write(lunout,*) 'itr_indice=',itr_indice
 !       IF (nqtot>=nqo+1) THEN
-        IF (nqtottr>=1) THEN
+         IF (nqtottr>=1) THEN
 !
             !DO iq=nqo+1,nqtot 
             ! C Risi: on modifie la boucle
-            do itr=1,nqtottr ! C Risi
+          DO itr=1,nqtottr ! C Risi
             iq=itr_indice(itr)  ! C Risi
             write(*,*) 'phys_output_mid 503: itr=',itr
   
             iiq=niadv(iq)
-            o_trac(itr) = ctrl_out((/ 1, 5, 5, 5, 10, 10, 11, 11, 11, 11 /), &
-                           tname(iiq),'Tracer '//ttext(iiq), "-",  &
-                           (/ '', '', '', '', '', '', '', '', '', '' /))
-            o_dtr_vdf(itr) = ctrl_out((/ 4, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'd'//trim(tname(iq))//'_vdf',  &
-                              'Tendance tracer '//ttext(iiq), "-" , &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_the(itr) = ctrl_out((/ 5, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'd'//trim(tname(iq))//'_the', &
-                              'Tendance tracer '//ttext(iiq), "-", &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_con(itr) = ctrl_out((/ 5, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'd'//trim(tname(iq))//'_con', &
-                              'Tendance tracer '//ttext(iiq), "-", &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_lessi_impa(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                     'd'//trim(tname(iq))//'_lessi_impa', &
-                                     'Tendance tracer '//ttext(iiq), "-", &
-                                     (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_lessi_nucl(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                     'd'//trim(tname(iq))//'_lessi_nucl', &
-                                     'Tendance tracer '//ttext(iiq), "-", &
-                                     (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_insc(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                               'd'//trim(tname(iq))//'_insc', &
-                               'Tendance tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_bcscav(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                 'd'//trim(tname(iq))//'_bcscav', &
-                                 'Tendance tracer '//ttext(iiq), "-", &
-                                 (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_evapls(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                 'd'//trim(tname(iq))//'_evapls', &
-                                 'Tendance tracer '//ttext(iiq), "-", &
-                                 (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_ls(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                             'd'//trim(tname(iq))//'_ls', &
-                             'Tendance tracer '//ttext(iiq), "-", &
-                             (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_trsp(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                               'd'//trim(tname(iq))//'_trsp', &
-                               'Tendance tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_sscav(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                'd'//trim(tname(iq))//'_sscav', &
-                                'Tendance tracer '//ttext(iiq), "-", &
-                                (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_sat(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                               'd'//trim(tname(iq))//'_sat', &
-                               'Tendance tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_uscav(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                                'd'//trim(tname(iq))//'_uscav', &
-                                'Tendance tracer '//ttext(iiq), "-", &
-                                 (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_dtr_dry(itr) = ctrl_out((/ 7, 7, 7, 7, 10, 10, 11, 11, 11, 11 /), &
-                              'cum'//'d'//trim(tname(iq))//'_dry', &
-                              'tracer tendency dry deposition'//ttext(iiq), "-", &
-                              (/ '', '', '', '', '', '', '', '', '', '' /))
-
-            o_trac_cum(itr) = ctrl_out((/ 1, 4, 10, 10, 10, 10, 11, 11, 11, 11 /), &
-                               'cum'//tname(iiq),&
-                               'Cumulated tracer '//ttext(iiq), "-", &
-                               (/ '', '', '', '', '', '', '', '', '', '' /))
-            ENDDO
-      ENDIF
+            dn = 'd'//TRIM(tracers(iiq)%name)//'_'
+
+            flag = [1, 5, 5, 5, 10, 10, 11, 11, 11, 11]
+            lnam = 'Tracer '//TRIM(tracers(iiq)%longName)
+            tnam = TRIM(tracers(iiq)%name); o_trac          (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            flag = [4, 7, 7, 7, 10, 10, 11, 11, 11, 11]
+            lnam = 'Tendance tracer '//TRIM(tracers(iiq)%longName)
+            tnam = TRIM(dn)//'vdf';         o_dtr_vdf       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            flag = [5, 7, 7, 7, 10, 10, 11, 11, 11, 11]
+            tnam = TRIM(dn)//'the';         o_dtr_the       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'con';         o_dtr_con       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            flag = [7, 7, 7, 7, 10, 10, 11, 11, 11, 11]
+            tnam = TRIM(dn)//'lessi_impa';  o_dtr_lessi_impa(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'lessi_nucl';  o_dtr_lessi_nucl(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'insc';        o_dtr_insc      (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'bcscav';      o_dtr_bcscav    (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'evapls';      o_dtr_evapls    (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'ls';          o_dtr_ls        (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'trsp';        o_dtr_trsp      (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'sscav';       o_dtr_sscav     (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'sat';         o_dtr_sat       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'uscav';       o_dtr_uscav     (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            lnam = 'tracer tendency dry deposition'//TRIM(tracers(iiq)%longName)
+            tnam = 'cum'//TRIM(dn)//'dry';  o_dtr_dry       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            flag = [1, 4, 10, 10, 10, 10, 11, 11, 11, 11]
+            lnam = 'Cumulated tracer '//TRIM(tracers(iiq)%longName)
+            tnam = 'cum'//TRIM(tracers(iiq)%name); o_trac_cum(itr)= ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+          ENDDO
+       ENDIF
 
    ENDDO !  iff
@@ -627,8 +585,8 @@
         write(*,*) 'phys_output_mid 589'
 #ifdef ISO
-  do ixt=1,ntraciso
-     if (ixt.le.niso) then
+    do ixt=1,ntraciso
+      if (ixt.le.niso) then
         striso_sortie=striso(ixt)
-     else
+      else
 #ifdef ISOTRAC
         iiso=index_iso(ixt)
@@ -639,70 +597,39 @@
         stop
 #endif
-     endif
-
-   o_xtprecip(ixt)=ctrl_out((/ 1, 1, 1, 10, 5, 10, 11, 11, 11, 11/), &
-    'precip'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Precip Totale liq+sol', 'kg/(s*m2)', (/ ('', i=1, 10) /))   
-   o_xtplul(ixt) = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11, 11/), &
-    'plul'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Large-scale Precip.', 'kg/(s*m2)', (/ ('', i=1, 10) /))
-   o_xtpluc(ixt) = ctrl_out((/ 1, 1, 1, 10, 5, 10, 11, 11, 11, 11/), &
-    'pluc'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Convective Precip.', 'kg/(s*m2)', (/ ('', i=1, 10) /))
-   o_xtevap(ixt) = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'evap'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Evaporat', 'kg/(s*m2)', (/ ('', i=1, 10) /))
-   o_xtovap(ixt) = ctrl_out((/ 2, 3, 4, 10, 10, 10, 11, 11, 11, 11/), &
-    'ovap'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Specific humidity', 'kg/kg', (/ ('', i=1, 10) /))
-   o_xtoliq(ixt) = ctrl_out((/ 2, 3, 4, 10, 10, 10, 11, 11, 11, 11/), &
-    'oliq'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Liquid water', 'kg/kg', (/ ('', i=1, 10) /))
-   o_xtcond(ixt) = ctrl_out((/ 2, 3, 4, 10, 10, 10, 11, 11, 11, 11/), &
-    'ocond'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Condensed water', 'kg/kg', (/ ('', i=1, 10) /))     
-   o_dxtdyn(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqdyn'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Dynamics dQ', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   o_dxtldyn(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqldyn'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Dynamics dQL', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   o_dxtcon(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqcon'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Convection dQ', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   o_dxteva(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqeva'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Reevaporation dQ', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   o_dxtlsc(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqlsc'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Condensation dQ', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   o_dxtajs(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqajs'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Dry adjust. dQ', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   o_dxtvdf(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqvdf'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Boundary-layer dQ', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   o_dxtthe(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'dqthe'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'Thermal dQ', '(kg/kg)/s', (/ ('', i=1, 10) /))
-
-   IF (ok_qch4) then
-     o_dxtch4(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-        'dqch4'//striso_sortie(1:lnblnk(striso_sortie)),  &
-    'H2O due to CH4 oxidation & photolysis', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   endif ! IF (ok_qch4) then
-
-   if (ixt.eq.iso_HTO) then
-      o_dxtprod_nucl(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-        'dqprodnucl'//striso_sortie(1:lnblnk(striso_sortie)),  &
-        'dHTO/dt due to nuclear production', '(kg/kg)/s', (/ ('', i=1, 10) /))
-      o_dxtcosmo(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-        'dqcosmo'//striso_sortie(1:lnblnk(striso_sortie)),  &
-        'dHTO/dt due to cosmogenic production', '(kg/kg)/s', (/ ('', i=1, 10) /))
-      o_dxtdecroiss(ixt) = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-        'dqdecroiss'//striso_sortie(1:lnblnk(striso_sortie)),  &
-        'dHTO/dt due to radiative destruction', '(kg/kg)/s', (/ ('', i=1, 10) /))
-   endif !if (ixt.eq.iso_HTO) then
-  enddo !do ixt=1,niso
+      endif
+
+      flag = [1,  1,  1, 10,  5, 10, 11, 11, 11, 11]; unit = 'kg/(s*m2)'
+      o_xtprecip(ixt)=ctrl_out(flag, 'precip'//TRIM(outiso), 'Precip Totale liq+sol', unit, [('',i=1,nfiles)])
+      o_xtpluc  (ixt)=ctrl_out(flag,   'pluc'//TRIM(outiso),    'Convective Precip.', unit, [('',i=1,nfiles)])
+
+      flag = [1,  1,  1, 10, 10, 10, 11, 11, 11, 11]
+      o_xtplul  (ixt)=ctrl_out(flag,   'plul'//TRIM(outiso),   'Large-scale Precip.', unit, [('',i=1,nfiles)])
+      o_xtevap  (ixt)=ctrl_out(flag,   'evap'//TRIM(outiso),             'Evaporat.', unit, [('',i=1,nfiles)])
+
+      flag = [2,  3,  4, 10, 10, 10, 11, 11, 11, 11]; unit = 'kg/kg'
+      o_xtovap  (ixt)=ctrl_out(flag,   'ovap'//TRIM(outiso),     'Specific humidity', unit, [('',i=1,nfiles)])
+      o_xtoliq  (ixt)=ctrl_out(flag,   'oliq'//TRIM(outiso),          'Liquid water', unit, [('',i=1,nfiles)])
+      o_xtcond  (ixt)=ctrl_out(flag,  'ocond'//TRIM(outiso),       'Condensed water', unit, [('',i=1,nfiles)])
+
+      flag = [4, 10, 10, 10, 10, 10, 11, 11, 11, 11]; unit = '(kg/kg)/s'
+      o_dxtdyn  (ixt)=ctrl_out(flag,  'dqdyn'//TRIM(outiso),           'Dynamics dQ', unit, [('',i=1,nfiles)])
+      o_dxtldyn (ixt)=ctrl_out(flag, 'dqldyn'//TRIM(outiso),          'Dynamics dQL', unit, [('',i=1,nfiles)])
+      o_dxtcon  (ixt)=ctrl_out(flag,  'dqcon'//TRIM(outiso),         'Convection dQ', unit, [('',i=1,nfiles)])
+      o_dxteva  (ixt)=ctrl_out(flag,  'dqeva'//TRIM(outiso),      'Reevaporation dQ', unit, [('',i=1,nfiles)])
+      o_dxtlsc  (ixt)=ctrl_out(flag,  'dqlsc'//TRIM(outiso),       'Condensation dQ', unit, [('',i=1,nfiles)])
+      o_dxtajs  (ixt)=ctrl_out(flag,  'dqajs'//TRIM(outiso),        'Dry adjust. dQ', unit, [('',i=1,nfiles)])
+      o_dxtvdf  (ixt)=ctrl_out(flag,  'dqvdf'//TRIM(outiso),     'Boundary-layer dQ', unit, [('',i=1,nfiles)])
+      o_dxtthe  (ixt)=ctrl_out(flag,  'dqthe'//TRIM(outiso),            'Thermal dQ', unit, [('',i=1,nfiles)])
+
+      IF(ok_qch4) o_dxtch4(ixt)=ctrl_out(flag, 'dqch4'//TRIM(outiso), 'H2O due to CH4 oxidation & photolysis', &
+                                                                                      unit, [('',i=1,nfiles)])
+      IF(ixt == iso_HTO) THEN
+      o_dxtprod_nucl(ixt)=ctrl_out(flag, 'dqprodnucl'//TRIM(outiso), 'dHTO/dt due to nuclear production',      &
+                                                                                      unit, [('',i=1,nfiles)])
+      o_dxtcosmo    (ixt)=ctrl_out(flag,    'dqcosmo'//TRIM(outiso), 'dHTO/dt due to cosmogenic production',   &
+                                                                                      unit, [('',i=1,nfiles)])
+      o_dxtdecroiss (ixt)=ctrl_out(flag, 'dqdecroiss'//TRIM(outiso), 'dHTO/dt due to radiative destruction',   &
+      END IF
+    enddo !do ixt=1,niso
 #endif
         write(*,*) 'phys_output_mid 596'
Index: LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmdiso/phys_output_write_mod.F90	(revision 4046)
@@ -25,5 +25,7 @@
 
     USE dimphy, ONLY: klon, klev, klevp1
-    USE infotrac_phy, ONLY: nbtr
+    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niadv, &
+        nqtottr,itr_indice
+    USE strings_mod,  ONLY: maxlen
     USE mod_phys_lmdz_para, ONLY: is_north_pole_phy,is_south_pole_phy
     USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
@@ -383,6 +385,4 @@
     USE pbl_surface_mod, ONLY: snow
     USE indice_sol_mod, ONLY: nbsrf
-    USE infotrac_phy, ONLY: nqtot, nqo, type_trac, tname, niadv, &
-        nqtottr,itr_indice ! C Risi: ajout nqtottr
 #ifdef ISO
     USE infotrac_phy, only: ntraciso,niso,nqtottr
@@ -467,5 +467,5 @@
     INTEGER ISW
     CHARACTER*1 ch1
-    CHARACTER*20 varname
+    CHARACTER(LEN=maxlen) :: varname, dn
 
 #ifdef CPP_XIOS
@@ -538,47 +538,52 @@
           DO iq=nqo+1, nqtot
             iiq=niadv(iq)
-            varname=trim(tname(iiq))
-            WRITE (lunout,*) 'XIOS var=', nqo, iq, nqtot, varname
+            dn = 'd'//TRIM(tracers(iiq)%name)//'_'
+            WRITE (lunout,*) 'XIOS var=', nqo, iq, nqtot, tracers(iiq)%name
+
+            unt = "kg kg-1"
+            varname=trim(tracers(iiq)%name)
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1")
-            varname='d'//trim(tname(iiq))//'_vdf'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+
+            unt = "kg kg-1 s-1"
+            varname=TRIM(dn)//'vdf'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_the'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'the'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_con'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'con'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_lessi_impa'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'lessi_impa'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_lessi_nucl'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'lessi_nucl'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_insc'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'insc'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_bcscav'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'bcscav'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_evapls'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'evapls'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_ls'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'ls'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_trsp'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'trsp'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_sscav'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'sscav'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_sat'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'sat'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_uscav'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'uscav'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
+            CALL xios_set_attr(child, name=varname, unit=unt)
           ENDDO
           !On ajoute les variables 2D traceurs par l interface fortran 
@@ -587,11 +592,15 @@
           DO iq=nqo+1, nqtot
             iiq=niadv(iq)
-            varname='cum'//trim(tname(iiq))
+
+            unt = "kg m-2"
+            varname='cum'//trim(tracers(iiq)%name)
             WRITE (lunout,*) 'XIOS var=', iq, nqtot, varname
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg m-2")
-            varname='cumd'//trim(tname(iiq))//'_dry'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+
+            unt = "kg m-2 s-1"
+            varname='cumd'//trim(tracers(iiq)%name)//'_dry'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg m-2 s-1")
+            CALL xios_set_attr(child, name=varname, unit=unt)
           ENDDO
     ENDIF
